var tabclickSettings = {

  /* Assign preferences service to variable*/
  tcPrefs: Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch(null),

  // variable needed for checking if Undo Close Tab is enabled
  noUndoCloseTab: true,

  // variable needed for checking if Merging in Duplicate Tab is enabled
  noDuplicateTabMerge: true,

  // variable needed for checking if Undo Close Tab from Click2Tab is enabled
  noC2TUndoCloseTab: true,

  // variable needed for checking if IEview is enabled
  noIEview: true,

  // variable needed for checking if SnapBackTab from SessionSaver is enabled
  noSSSnapBackTab: true,

  // variables needed for checking if tablib is present and activated
  tablibDisabled: true,
  tablibUsed: false,

  // variable to check if TBP is installed and is set to load the homepage in a new tab
  TBPloadhome: false,

  // variable to check for add bookmark in Suite / Seamonkey
  bmOption: false,

  // variable to check if bookmarkalltabs is supported
  bmAllTabs: false,

  /* Assign used element id's to constants */
  Consts:
  {
    SETTINGS_IDS: ['tabclicking-tab-dblclick-settings', 'tabclicking-tabbar-dblclick-settings',
                'tabclicking-tab-mddlclick-settings', 'tabclicking-tabbar-mddlclick-settings',
                'tabclicking-tab-ctrlclick-settings', 'tabclicking-tabbar-ctrlclick-settings',
                'tabclicking-tab-altclick-settings', 'tabclicking-tabbar-altclick-settings',
                'tabclicking-tab-shiftclick-settings', 'tabclicking-tabbar-shiftclick-settings'],
    MIDDLE_CLICK_CHECK_ID: 'tabclicking-mddlclick-contentloadurl-check'
  },

  /* Set values of checkboxes and menuitems to current preferences for extension */
  onLoad: function()
  {
    var i;
    var actionNum = this.tcPrefs.getCharPref("extensions.tabclicking.action");
    var selectNewTabNum = this.tcPrefs.getCharPref("extensions.tabclicking.select_new_tab");
    var winMediator= Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
    var prevWindow = winMediator.getMostRecentWindow('navigator:browser');

    // check if TBP is installed and is set to load the homepage in a new tab
    if (prevWindow.TBP_init)
    {
      try {
        this.TBPloadhome = this.tcPrefs.getBoolPref("extensions.tabprefs.loadHome");
      }
      catch(e) {}
    }

    // check if undo close tab is available (Firefox 2 or undoclosetab extension)
    if (prevWindow.undoCloseTab || prevWindow.getBrowser().undoRemoveTab)
      this.noUndoCloseTab = false;

    // check if tablib is enabled and activated
    if (prevWindow.getBrowser().moveTabTo)
    {
      this.tablibDisabled = false;
      if (prevWindow.tabClicking.tablib.tablibPref
          && this.tcPrefs.getBoolPref(prevWindow.tabClicking.tablib.tablibPref))
        this.tablibUsed = true;
    }

    // check if Duplicate Tab with Merging is enabled
    if (prevWindow.dtMergeWindows && prevWindow.dtMergeWindows.selectBrowser)
      this.noDuplicateTabMerge = false;

    // check if Click2Tab's Undo Close Tab is enabled
    if (prevWindow.TabbrowserClick2Tab && prevWindow.TabbrowserClick2Tab.undoLastClosedTab)
      this.noC2TUndoCloseTab = false;

    // check if IEview is enabled
    if (prevWindow.IeView && prevWindow.IeView.ieViewLaunch)
      this.noIEview = false;

    // check if SessionSaver's SnapBack Tab is enabled
    if (prevWindow.SessionSaver && prevWindow.SessionSaver.snapBackTab)
      this.noSSSnapBackTab = false;

    // check for add bookmark in Suite/Seamonkey
    if (prevWindow.BookmarksUtils && prevWindow.BookmarksUtils.addBookmarkForBrowser)
      this.bmOption = true;

    // check if BookMarkAllTabs is supported (Firefox 1.5 and up)
    if (prevWindow.addBookmarkForTabBrowser || prevWindow.addGroupmarkAs ||
        prevWindow.PlacesCommandHook)
      this.bmAllTabs = true;

    for (i=0; i<this.Consts.SETTINGS_IDS.length; i++)
    {
      // show menuitems containing actions from other extensions if those extensions are installed
      document.getElementById(this.Consts.SETTINGS_IDS[i]).showUCT(this.noUndoCloseTab);
      document.getElementById(this.Consts.SETTINGS_IDS[i]).showMerge(this.noDuplicateTabMerge);
      document.getElementById(this.Consts.SETTINGS_IDS[i]).showC2T(this.noC2TUndoCloseTab);
      document.getElementById(this.Consts.SETTINGS_IDS[i]).showIEview(this.noIEview);
      document.getElementById(this.Consts.SETTINGS_IDS[i]).showSBTab(this.noSSSnapBackTab);
      document.getElementById(this.Consts.SETTINGS_IDS[i]).showBMAllTabs(!this.bmAllTabs);
      document.getElementById(this.Consts.SETTINGS_IDS[i]).showBMOption = this.bmOption;

      var menuitemNum = parseInt(actionNum.charAt(i), 20);
      document.getElementById(this.Consts.SETTINGS_IDS[i]).menuitem = menuitemNum;
      switch (menuitemNum)
      {
        case 1: // new tab
        case 7: // duplicate tab
          document.getElementById(this.Consts.SETTINGS_IDS[i]).setDeck(0, false);
          break;
        /*case 2: // reload tab
          document.getElementById(this.Consts.SETTINGS_IDS[i]).setDeck(0, true);
          break;*/
        case 9: // undo close tab
          if (this.noUndoCloseTab)
            document.getElementById(this.Consts.SETTINGS_IDS[i]).menuitem = 0;
          document.getElementById(this.Consts.SETTINGS_IDS[i]).setDeck(1);
          break;
        case 10: // merge windows
          if (this.noDuplicateTabMerge)
          {
            document.getElementById(this.Consts.SETTINGS_IDS[i]).menuitem = 0;
            document.getElementById(this.Consts.SETTINGS_IDS[i]).setDeck(1);
          }
          else if (!this.noDuplicateTabMerge)
            document.getElementById(this.Consts.SETTINGS_IDS[i]).setDeck(2);
          break;
        case 11: // click2tab undo remove tab
          if (this.noC2TUndoCloseTab)
          {
            document.getElementById(this.Consts.SETTINGS_IDS[i]).menuitem = 0;
            document.getElementById(this.Consts.SETTINGS_IDS[i]).setDeck(1);
          }
          else if (!this.noC2TUndoCloseTab)
            document.getElementById(this.Consts.SETTINGS_IDS[i]).setDeck(3);
          break;
        case 12: // ie view
          if (this.noIEview)
          {
            document.getElementById(this.Consts.SETTINGS_IDS[i]).menuitem = 0;
            document.getElementById(this.Consts.SETTINGS_IDS[i]).setDeck(1);
          }
          else if (!this.noIEview)
            document.getElementById(this.Consts.SETTINGS_IDS[i]).setDeck(4);
          break;
        case 13: // snapbacktab
          if (this.noSSSnapBackTab)
          {
            document.getElementById(this.Consts.SETTINGS_IDS[i]).menuitem = 0;
            document.getElementById(this.Consts.SETTINGS_IDS[i]).setDeck(1);
          }
          else if (!this.noSSSnapBackTab)
            document.getElementById(this.Consts.SETTINGS_IDS[i]).setDeck(5);
          break;
        case 14: // Bookmark Tab
          document.getElementById(this.Consts.SETTINGS_IDS[i]).setBMOption();
          break;
        case 15: // Bookmark All Tabs
          if (!this.bmAllTabs)
            document.getElementById(this.Consts.SETTINGS_IDS[i]).menuitem = 0;
          document.getElementById(this.Consts.SETTINGS_IDS[i]).setDeck(1);
          break;
        default:
          document.getElementById(this.Consts.SETTINGS_IDS[i]).setDeck(1);
      }
      document.getElementById(this.Consts.SETTINGS_IDS[i]).newtab = parseInt(selectNewTabNum.charAt(i));
      document.getElementById(this.Consts.SETTINGS_IDS[i]).disableCheckBox(0, this.TBPloadhome);
      document.getElementById(this.Consts.SETTINGS_IDS[i]).disableCheckBox(1, this.tablibDisabled, this.tablibUsed);
    }
    var checkbox = document.getElementById(this.Consts.MIDDLE_CLICK_CHECK_ID);
    checkbox.addEventListener("CheckboxStateChange", this.checkMiddleClick, false);
    var prefloaded = this.tcPrefs.getBoolPref("middlemouse.contentLoadURL");
    checkbox.checked = prefloaded;
      /* When setting all to default, Selecting Tabs for Merging (from Duplicate Tab extension) should be set to ctrl-click */
    if ((this.tcPrefs.prefIsLocked("extensions.tabclicking.action")) && (!this.noDuplicateTabMerge))
    {
      document.getElementById(this.Consts.SETTINGS_IDS[4]).setDeck(2);
      document.getElementById(this.Consts.SETTINGS_IDS[4]).menuitem = 10;
    }
   },

  checkMiddleClick: function()
  {
      /* Check if option middleclick contentloadUrl is set to true (paste and load url on middle click) */
    var itemchecked = document.getElementById(tabclickSettings.Consts.MIDDLE_CLICK_CHECK_ID).checked;
    for (var i = 2; i < 4; i++) {
      document.getElementById(tabclickSettings.Consts.SETTINGS_IDS[i]).disabledmenu = itemchecked;
    }
  },

  /* Set values of checkboxes and menulist to default preferences for extension*/
  setDefaults: function()
  {
    this.tcPrefs.lockPref("extensions.tabclicking.action");
    this.tcPrefs.lockPref("extensions.tabclicking.select_new_tab");

    this.onLoad();

    if (this.tcPrefs.prefIsLocked("extensions.tabclicking.action"))
      this.tcPrefs.unlockPref("extensions.tabclicking.action");
    if (this.tcPrefs.prefIsLocked("extensions.tabclicking.select_new_tab"))
      this.tcPrefs.unlockPref("extensions.tabclicking.select_new_tab");
  },

  /* change preferences to user selected values */
  onAccept: function()
  {
    var i, actionstring = "", checkstring1 = "", checkstring2 = "", newtabstring = "";
    for (i = 0; i < this.Consts.SETTINGS_IDS.length; i++) {
      var menuitemNum = document.getElementById(this.Consts.SETTINGS_IDS[i]).menuitem;
      var newtab = document.getElementById(this.Consts.SETTINGS_IDS[i]).newtab;
      actionstring += menuitemNum.toString(20);
      newtabstring += newtab.toString();
    }
    this.tcPrefs.setCharPref("extensions.tabclicking.action", actionstring);
    this.tcPrefs.setCharPref("extensions.tabclicking.select_new_tab", newtabstring);
    var itemchecked = document.getElementById(this.Consts.MIDDLE_CLICK_CHECK_ID).checked;
    this.tcPrefs.setBoolPref("middlemouse.contentLoadURL", itemchecked);
  },

  onCancel: function() {
  }

}
